﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Diagnostics;

namespace picfiltergui
{
    public partial class Form1 : Form
    {
        //the arguments for the log file
        private String _sourcefolderPath;
        private string _folderName;
        private int _includeSubFolders;
        private int _saveUnsorted;
        private int _isAuto;
        private int _success;

      // These are the Win32 error code for file not found or access denied.
        const int ERROR_FILE_NOT_FOUND =2;
        const int ERROR_ACCESS_DENIED = 5;


        public Form1()
        {
            InitializeComponent();
            //intialize the arguments
            _sourcefolderPath = null;
            _folderName = "unsorted";
            _includeSubFolders = 0;
            _saveUnsorted = 1;
            _isAuto = 0;
            _success = 1;
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {
            if ((_sourcefolderPath == null) || (_isAuto == 0 && !manual.Checked))
            {
                MessageBox.Show("Please enter all the details");
                return;
            }

            ImageLayout backgroundImageLayout = Form1.ActiveForm.BackgroundImageLayout;
            //writing the log file:
            String tempath = Path.GetTempPath();
   
            String logFileForMatlab = tempath + "log2matlab.txt";
            String logFileFromMatlab = tempath + "log2c.txt";

            if (File.Exists(logFileForMatlab))
                File.Delete(logFileForMatlab);

            string logText = _sourcefolderPath +"\\"+ Environment.NewLine
                             + _includeSubFolders + Environment.NewLine
                             + _saveUnsorted + Environment.NewLine
                             + _folderName + Environment.NewLine
                             + _isAuto;
            File.WriteAllText(logFileForMatlab, logText);



/////////////////////////////RUNING MATLAB////////////////////////////
           Process myProcess = new Process();
            
            try
            {
                myProcess.StartInfo.FileName = Directory.GetCurrentDirectory() + "\\" + "picfilter.exe";
                myProcess.StartInfo.CreateNoWindow = true;
                myProcess.Start();
                myProcess.WaitForExit();
            }
            catch (Win32Exception err)
            {
                if(err.NativeErrorCode == ERROR_FILE_NOT_FOUND)
                {
                    MessageBox.Show(err.Message);
                } 
            }
 
/////////////////////////////////END///////////////////////////////////

        // reading from the the matlab log file:
            string[] picture_list = null;
            if (File.Exists(logFileFromMatlab))
                picture_list = File.ReadAllLines(logFileFromMatlab);
            else
                return;

            if (picture_list.Last() == "1")
                _success = 1;
            else
                _success = 0;


            if(manual.Checked && picture_list.Length > 3)
            {   
                viewer manual_filter = new viewer();
                int list_size = picture_list.Length;
                for (int i = 0; i < list_size ; i++)
                    manual_filter.listOfFiles.Add(picture_list[i]);
                manual_filter.folder_name = _folderName;
                manual_filter.saveUnsorted = _saveUnsorted;
                manual_filter.ShowDialog();
                _success = manual_filter.success;
            }
           if(_success == 1)
               MessageBox.Show("Operation Completed Successfully!");
 
//delete the logs file in the end of the process
           File.Delete(logFileForMatlab);
           File.Delete(logFileFromMatlab);
        }
       
        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            if (manual.Checked)
                _isAuto = 0;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            FolderBrowserDialog fb = new FolderBrowserDialog();
            if (fb.ShowDialog() == DialogResult.OK)
            {
                textBoxFolder.Text = fb.SelectedPath;
                _sourcefolderPath = textBoxFolder.Text;
            }
        }
        private void textBoxFolder_TextChanged(object sender, EventArgs e)
        {
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            _folderName = textBoxFolderName.Text;
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            if (UnsortedCheckBox.Checked)
               {
                   _saveUnsorted = 0;
                   textBoxFolderName.AcceptsReturn = false;
                   textBoxFolderName.Enabled = false;
                   textBoxFolderName.HideSelection = false;
                   textBoxFolderName.Text = "";
                   _folderName = "unsorted";
                   chooseNameLabel.Enabled = false;
               }
           else
               {
                   _saveUnsorted = 1;
                   textBoxFolderName.AcceptsReturn = true;
                   textBoxFolderName.Enabled = true;
                   textBoxFolderName.HideSelection = true;
                   chooseNameLabel.Enabled = true;
               }
        }

        private void auto_CheckedChanged(object sender, EventArgs e)
        {
            if (auto.Checked)
                _isAuto = 1;
        }

        private void subFolders_CheckedChanged(object sender, EventArgs e)
        {
            if (subFolders.Checked)
                _includeSubFolders = 1;
            else
                _includeSubFolders = 0;
        }

        private void chooseNameLabel_Click(object sender, EventArgs e)
        {

        }
    }
}
