function searchInOneFolderIntegration()
    global SAVETHEFILTEREDFILES UNNECESSARYFILESFOLDER INCLUDESUBFOLDERS FILETYPES SEARCHTYPE;
    logFileDir = tempdir;
    logFileName = 'log2matlab.txt';
    fullFileName = [logFileDir logFileName];
    INCLUDESUBFOLDERS = 0;
    SAVETHEFILTEREDFILES = 0;
    SEARCHTYPE = 0;
    % reading file into function variables
    file = fopen(fullFileName);
    currPath = fgetl(file);
    temp = fgetl(file);

    if (strcmp(temp,'1')==1)
        INCLUDESUBFOLDERS = 1;
    end
    % if user wants to include all subfolder - 1, otherwise - 0
    temp = fgetl(file);
    if (strcmp(temp,'1')==1)
        SAVETHEFILTEREDFILES = 1;
    end
    % if user wants to save the unnecessary files - 1, otherwise - 0
    UNNECESSARYFILESFOLDER = fgetl(file);
    % will be created in every directory
    temp = fgetl(file);
    if (strcmp(temp,'1')==1)
        SEARCHTYPE = 1;
    end
    %SEARCHTYPE+SAVETHEFILTEREDFILES+INCLUDESUBFOLDERS+1
    % auto mode is 1, semi auto is 0
    fclose(file);
    FILETYPES = {'jpg' , 'png' , 'bmp'};                       % all pictures filetypes
    
    tempp=[char(64),char(64),char(10)];
    if ~SEARCHTYPE
        logIt(tempp);
    end

    if ~INCLUDESUBFOLDERS
        for filenameType=1:length(FILETYPES)
            makeSearch((setListOfOneFileTypeInFolder(currPath, char(FILETYPES(filenameType)))), currPath);
        end
    else
        makeSearchIncludeSubFolder(currPath);
    end
    logIt('1');
end

%{
gets:
	path of files
    fileType - the wanted extension
actions:
    create a vector with all pictures in the wanted extension
%}
function makeSearchIncludeSubFolder(path)
    global UNNECESSARYFILESFOLDER  FILETYPES
    for filenameType=1:length(FILETYPES)
        makeSearch((setListOfOneFileTypeInFolder(path, char(FILETYPES(filenameType)))), path);
    end
    allFileandDir = dir(path);
    for k=1:length(allFileandDir)
        if allFileandDir(k).isdir
            if ~(strcmp(allFileandDir(k).name , '.') || strcmp(allFileandDir(k).name , '..') || strcmp(allFileandDir(k).name , UNNECESSARYFILESFOLDER))
                newpath=[path char(allFileandDir(k).name) '\'];
                %if ~strcmp(newpath , dirForUnsortFile)
                    makeSearchIncludeSubFolder(newpath)
                %end
            end
        end
    end
end

function listOfOneType = setListOfOneFileTypeInFolder (path, fileType)
    directoryPath = [path '*.' fileType];
    listOfOneType = dir(directoryPath);
end
%{
gets:
	vector that contains all of the filenames with specific extension in specific folder and
	path of the files
	search type - 1 for a fully automatic method, 0 - semi-auto
actions:
    in auto mod, the function "bestPictureOfTwo" selects automaticlly the best picture between two similar pictures
    in semi-auto mod, this function create a vector which contains all similar pictures. each set of similar pictures seperated by '\n', and sends it to function "addToLog"
    in both cases, when a picture without any other similar pictures was found - it sends it to "save" function
%}
function makeSearch(picsOfOneType, path) %future - saveTheFilteredFiles
    global SAVETHEFILTEREDFILES UNNECESSARYFILESFOLDER SEARCHTYPE
    similarStr = [];
    dirForUnsortFile = [path UNNECESSARYFILESFOLDER '\'];
    if SEARCHTYPE & SAVETHEFILTEREDFILES
        if ~exist(dirForUnsortFile) 
            mkdir(dirForUnsortFile)
        end
    end
    if  length(picsOfOneType) <2
        return
    end
    pic1 = [path picsOfOneType(1).name];
    pic2 = [path picsOfOneType(2).name];

    iterationV = 1;
    lastCoupleWasSimilar = 0;

    while (iterationV < length(picsOfOneType))

        while (compareBetweenTwoPictures(pic1,pic2) && iterationV < length(picsOfOneType))

            lastCoupleWasSimilar = 1;
            if ~SEARCHTYPE %manual
                similarStr = [similarStr,pic1,char(10)]; %#ok<AGROW>
                pic1=pic2;
            else
                bestPic = bestPictureOfTwo(pic1, pic2);
                if strcmp(bestPic , pic1)
                    % if we need to save the "other" pictures then use this
                    % function else delete
                    if SAVETHEFILTEREDFILES 
                        movefile(pic2 , dirForUnsortFile , 'f')
                    else
                        delete (pic2)
                    end
                else
                    if SAVETHEFILTEREDFILES
                        movefile(pic1 , dirForUnsortFile , 'f')
                    else
                        delete (pic1)
                    end
                end
                pic1 = bestPic;
            end

            if (iterationV < (length(picsOfOneType)-1))
                pic2 = [path picsOfOneType(iterationV+2).name];
			else
				iterationV = iterationV+1;
				break;
            end

            iterationV = iterationV+1;
        end

        if ~SEARCHTYPE
            if (lastCoupleWasSimilar)
                similarStr = [similarStr,pic1,char(10),char(64),char(64),char(10)]; %#ok<AGROW>
                lastCoupleWasSimilar = 0;
            else
                save(pic1)
            end
            if (iterationV == (length(picsOfOneType)-1))
                save (pic2)
            end
        end
        pic1 = pic2;

        if (iterationV < (length(picsOfOneType)-1))
            pic2 = [path picsOfOneType(iterationV+2).name];
        end
        iterationV = iterationV+1;
    end
    if ~isempty(similarStr)
        logIt(similarStr);
    end
end

%{
gets:
	two pictures (actually it's filenames with full path)
actions:
    converting images to grey, then re-arrages their values in a histogram
    (2x255 - two lines - first line (call it x) is between 1 to 255 (x[1]=1, x[2]=2 and so on),
    second line is for summing how many cells in the pictures has the value as x[i]).
    then it's calculate the value in precentage for each cell.
    the last action is summing the absolute difference between this two pictures,
    and comparing it with diffValue, which is the value that deterime if two pictures are similar
%}
function isSimilar = compareBetweenTwoPictures(pic1,pic2)
    diffValue = 0.5;
    A1=rgb2gray(imread(pic1));
    A2=rgb2gray(imread(pic2));
    [a1,b1]=hist(A1(:),1:255); %#ok<NASGU>
    [a2,b2]=hist(A2(:),1:255); %#ok<NASGU>
    a1=a1./sum(a1);
    a2=a2./sum(a2);
    diff2Picture=sum(abs(a1-a2));
    if (diff2Picture < diffValue)
        isSimilar=1;
    else
        isSimilar=0;
    end
end

%{
gets:
	two similar pictures (actually it's filenames with full path)
actions:
    returns the bigger picture
%}
function pic =  bestPictureOfTwo(pic1, pic2)
    dirp1 = dir(pic1);
    dirp2 = dir(pic2);
    if dirp1.bytes > dirp2.bytes
        pic = pic1;
    else
        pic = pic2;
    end
end

%just for now
function save(pic)
    pic; %#ok<VUNUS>
end

%just for now
function logIt(addToLog)
    tempD=tempdir; 
%     if isdeployed
%         tempD = ['C:\Users\Administrator\Documents\MATLAB\picfilter\distrib\temp\'];
%     end   
    filename =  'log2c.txt';
    fullfilename = [tempD, filename];
    fid=fopen(fullfilename,'a' );
    fwrite(fid,addToLog);
    fclose(fid);
end